// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNChoiceSetEventParser.hpp"

using namespace Dawn;

std::vector<std::string> VNChoiceSetEventParser::getRequiredAttributes() {
  return { "key", "value" };
}

std::map<std::string, std::string> VNChoiceSetEventParser::getOptionalAttributes() {
  return {};
}

int32_t VNChoiceSetEventParser::onParse(
  Xml *node,
  std::map<std::string, std::string> values,
  struct VNChoiceSetEvent *out,
  std::string *error
) {
  out->key = values["key"];
  out->value = values["value"];
  return 0;
}