// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"
#include <regex>

namespace Dawn {
  struct VNMarker {
    std::string name;
  };

  class VNMarkerParser : public XmlParser<struct VNMarker> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNMarker *out,
        std::string *error
      ) override;
  };
}